%define uid		52
%define username	saslauth
%define hint		"Saslauthd user"
%define homedir		%{_var}/empty/%{username}

%define _plugindir2 %{_libdir}/sasl2
%define bootstrap_cyrus_sasl 1

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	The Cyrus SASL library.
Name:      	cyrus-sasl
Version:   	2.1.23
Release:   	3
BuildArch:	i686
License: 	GNU/GPL
URL:		http://asg.web.cmu.edu/sasl/sasl-library.html
Group:     	System/Libraries
# Source0 originally comes from ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/;
# make-no-dlcompatorsrp-tarball.sh removes the "dlcompat" subdirectory and builds a
# new tarball.
Source0: 	cyrus-sasl-%{version}-nodlcompatorsrp.tar.gz
Source4: 	saslauthd.init
Source7: 	sasl-mechlist.c
Source8: 	sasl-checkpass.c
Source9: 	saslauthd.sysconfig
Source10: 	make-no-dlcompatorsrp-tarball.sh
Patch11: 	cyrus-sasl-2.1.18-no_rpath.patch
Patch15: 	cyrus-sasl-2.1.20-saslauthd.conf-path.patch
Patch24: 	cyrus-sasl-2.1.21-sizes.patch
Patch25: 	cyrus-sasl-2.1.22-typo.patch
Patch26: 	cyrus-sasl-2.1.22-digest-commas.patch
Patch27: 	cyrus-sasl-2.1.22-automake-1.10.patch
Patch28: 	cyrus-sasl-2.1.21-keytab.patch
Patch30: 	cyrus-sasl-2.1.22-rimap.patch
Patch31: 	cyrus-sasl-2.1.22-kerberos4.patch
Patch32: 	cyrus-sasl-2.1.22-warnings.patch
Patch33: 	cyrus-sasl-2.1.22-current-db.patch
Patch34: 	cyrus-sasl-2.1.22-ldap-timeout.patch
Patch35: 	cyrus-sasl-2.1.22-bad-elif.patch
BuildRequires:	sqlite-devel
#Automatically resolved build dependencies
BuildRequires: e2fsprogs-devel
BuildRequires: gdbm-devel
BuildRequires: glibc-devel
BuildRequires: krb5-devel
BuildRequires: mysql-devel
BuildRequires: openldap-devel
BuildRequires: openssl-devel
BuildRequires: pam-devel
BuildRequires: zlib-devel mysql-devel db-devel groff
Requires(post): chkconfig
Requires(pre): /usr/sbin/useradd /usr/sbin/groupadd
Requires(postun): /usr/sbin/userdel /usr/sbin/groupdel
Requires: /sbin/nologin
Provides: user(%username) = %uid
Provides: group(%username) = %uid

%description
The %{name} package contains the Cyrus implementation of SASL.
SASL is the Simple Authentication and Security Layer, a method for
adding authentication support to connection-based protocols.

%package lib
Group: 		System/Libraries
Summary: 	Shared libraries needed by applications which use Cyrus SASL

%description lib
The %{name}-lib package contains shared libraries which are needed by
applications which use the Cyrus SASL library.

%package devel
Requires: 	%{name}-lib = %{version}-%{release}
Requires: 	%{name} = %{version}-%{release}
Group: 		Development/Libraries
Summary: 	Files needed for developing applications with Cyrus SASL

%description devel
The %{name}-devel package contains files needed for developing and
compiling applications which use the Cyrus SASL library.

%package gssapi
Requires: 	%{name}-lib = %{version}-%{release}
Group: 		System/Libraries
Summary: 	GSSAPI authentication support for Cyrus SASL

%description gssapi
The %{name}-gssapi package contains the Cyrus SASL plugins which
support GSSAPI authentication. GSSAPI is commonly used for Kerberos
authentication.

%package plain
Requires: 	%{name}-lib = %{version}-%{release}
Group: 		System/Libraries
Summary: 	PLAIN and LOGIN authentication support for Cyrus SASL

%description plain
The %{name}-plain package contains the Cyrus SASL plugins which support
PLAIN and LOGIN authentication schemes.

%package md5
Requires: 	%{name}-lib = %{version}-%{release}
Group: 		System/Libraries
Summary: 	CRAM-MD5 and DIGEST-MD5 authentication support for Cyrus SASL

%description md5
The %{name}-md5 package contains the Cyrus SASL plugins which support
CRAM-MD5 and DIGEST-MD5 authentication schemes.

%package ntlm
Requires: 	%{name}-lib = %{version}-%{release}
Group: 		System/Libraries
Summary: 	NTLM authentication support for Cyrus SASL

%description ntlm
The %{name}-ntlm package contains the Cyrus SASL plugin which supports
the NTLM authentication scheme.

%package sql
Requires: 	%{name}-lib = %{version}-%{release}
Group: 		System/Libraries
Summary: 	SQL auxprop support for Cyrus SASL

%description sql
The %{name}-sql package contains the Cyrus SASL plugin which supports
using a RDBMS for storing shared secrets.

%if ! %{bootstrap_cyrus_sasl}
%package ldap
Requires: 	%{name}-lib = %{version}-%{release}
Group: 		System/Libraries
Summary: 	LDAP auxprop support for Cyrus SASL

%description ldap
The %{name}-ldap package contains the Cyrus SASL plugin which supports using
a directory server, accessed using LDAP, for storing shared secrets.
%endif

%prep
%setup -q
chmod -x doc/*.html
chmod -x include/*.h
%patch11 -p1 -b .no_rpath
%patch15 -p1 -b .path
%patch24 -p1 -b .sizes
%patch25 -p1 -b .typo
%patch26 -p2 -b .digest-commas
%patch27 -p1 -b .automake-1.10
%patch28 -p1 -b .keytab
%patch30 -p1 -b .rimap
%patch31 -p1 -b .krb4
%patch32 -p1 -b .warnings
%patch33 -p1 -b .current-db
%patch34 -p1 -b .ldap-timeout
%patch35 -p1 -b .elif

# FIXME - we remove these files directly so that we can avoid using the -f
# flag, which has a nasty habit of overwriting files like COPYING.
rm -f config/config.guess config/config.sub 
rm -f config/ltconfig config/ltmain.sh config/libtool.m4
rm -fr autom4te.cache
libtoolize -c
aclocal -I config -I cmulocal
automake -a -c
autoheader
autoconf

pushd saslauthd
rm -f config/config.guess config/config.sub 
rm -f config/ltconfig config/ltmain.sh config/libtool.m4
rm -fr autom4te.cache
libtoolize -c
aclocal -I config -I ../cmulocal -I ../config
automake -a -c
autoheader
autoconf
popd

%build
CFLAGS="$RPM_OPT_FLAGS -fPIC"; export CFLAGS

# Find Kerberos.
krb5_prefix=`krb5-config --prefix`
if test x$krb5_prefix = x%{_prefix} ; then
        krb5_prefix=
else
        CPPFLAGS="-I${krb5_prefix}/include"; export CPPFLAGS
        CFLAGS="-I${krb5_prefix}/include $CFLAGS"
        LDFLAGS="-L${krb5_prefix}/%{_lib}"; export LDFLAGS
fi

# Find OpenSSL.
LIBS="-lcrypt"; export LIBS
if pkg-config openssl ; then
        CPPFLAGS="`pkg-config --cflags-only-I openssl` $CPPFLAGS"; export CPPFLAGS
        CFLAGS="`pkg-config --cflags openssl` $CFLAGS"; export CFLAGS
        LDFLAGS="`pkg-config --libs-only-L openssl` $LDFLAGS"; export LDFLAGS
fi

# Find the SQL libraries used needed by the SQL auxprop plugin.
mysql_config=mysql_config

SQL_CFLAGS=`${mysql_config} --cflags`
SQL_LIBS=`${mysql_config} --libs`
SQL_CFLAGS=`eval echo "$SQL_CFLAGS" | sed -e 's,-I%{_includedir}[^/],,g' -e 's,-I%{_includedir}$,,g' -e 's,[[:blank:]]+, ,g'`
SQL_LIBS=`eval echo "$SQL_LIBS" | sed -e 's,-L%{_libdir}[^/],,g' -e 's,-L%{_libdir}$,,g' -e 's,[[:blank:]]+, ,g'`
SQL_LDFLAGS=`eval echo "$SQL_LIBS" | sed -e 's,-[^L][^ ]*,,g'`
echo $SQL_LDFLAGS
SQL_LIBS=`eval echo "$SQL_LIBS" | sed -e 's,-[^l][^ ]*,,g'`
echo $SQL_LIBS

cleanup_flags() {
        sed -r -e 's,-D_GNU_SOURCE(=[^[:blank:]]+)?,,g' \
               -e 's,-D_FILE_OFFSET_BITS=[[:digit:]]+,,g' \
               -e 's,-D_LARGEFILE_SOURCE(=[^[:blank:]]+)?,,g' \
               -e 's,[[:blank:]]+, ,g'
}
CFLAGS=`echo $CFLAGS $SQL_CFLAGS | cleanup_flags`; export CFLAGS
CPPFLAGS=`echo $CPPFLAGS $SQL_CFLAGS | cleanup_flags`; export CPPFLAGS
LDFLAGS=`echo $LDFLAGS $SQL_LDFLAGS | cleanup_flags`; export LDFLAGS


%configure \
        --enable-shared --disable-static \
        --disable-java \
        --with-plugindir=%{_plugindir2} \
        --with-configdir=%{_plugindir2}:%{_sysconfdir}/sasl2 \
        --disable-krb4 \
        --enable-gssapi${krb5_prefix:+=${krb5_prefix}} \
        --with-gss_impl=mit \
        --with-rc4 \
        --with-dblib=berkeley \
        --with-saslauthd=/var/run/saslauthd --without-pwcheck \
%if ! %{bootstrap_cyrus_sasl}
        --with-ldap \
%endif
        --with-devrandom=/dev/urandom \
        --enable-anon \
        --enable-cram \
        --enable-digest \
        --enable-ntlm \
        --enable-plain \
        --enable-login \
        --disable-otp \
%if ! %{bootstrap_cyrus_sasl}
        --enable-ldapdb \
%endif
        --enable-sql --with-mysql=%{_prefix} \
        --without-sqlite \
        "$@"
        # --enable-auth-sasldb -- EXPERIMENTAL
make sasldir=%{_plugindir2}
make -C saslauthd testsaslauthd
make -C sample

# Build a small program to list the available mechanisms, because I need it.
pushd lib
../libtool --tag=CC --mode=link %{__cc} -o sasl2-shared-mechlist -I../include $CFLAGS %{SOURCE7} $LDFLAGS ./libsasl2.la

%install
test "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT sasldir=%{_plugindir2}
make install DESTDIR=$RPM_BUILD_ROOT sasldir=%{_plugindir2} -C plugins

install -m755 -d $RPM_BUILD_ROOT%{_bindir}
./libtool --tag=CC --mode=install \
install -m755 sample/client $RPM_BUILD_ROOT%{_bindir}/sasl2-sample-client
./libtool --tag=CC --mode=install \
install -m755 sample/server $RPM_BUILD_ROOT%{_bindir}/sasl2-sample-server
./libtool --tag=CC --mode=install \
install -m755 saslauthd/testsaslauthd $RPM_BUILD_ROOT%{_sbindir}/testsaslauthd

# Install the saslauthd mdoc page in the expected location.  Sure, it's not
# really a man page, but groff seems to be able to cope with it.
install -m755 -d $RPM_BUILD_ROOT%{_mandir}/man8/
install -m644 -p saslauthd/saslauthd.mdoc $RPM_BUILD_ROOT%{_mandir}/man8/saslauthd.8

# Create the saslauthd listening directory.
install -m755 -d $RPM_BUILD_ROOT/var/run/saslauthd

# Install the init script for saslauthd and the init script's config file.
install -m755 -d $RPM_BUILD_ROOT/etc/rc.d/init.d $RPM_BUILD_ROOT/etc/sysconfig
install -m755 -p %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d/saslauthd
install -m644 -p %{SOURCE9} $RPM_BUILD_ROOT/etc/sysconfig/saslauthd

# Install the config dirs if they're not already there.
install -m755 -d $RPM_BUILD_ROOT/%{_sysconfdir}/sasl2
install -m755 -d $RPM_BUILD_ROOT/%{_plugindir2}

# Provide an easy way to query the list of available mechanisms.
./libtool --tag=CC --mode=install \
install -m755 lib/sasl2-shared-mechlist $RPM_BUILD_ROOT/%{_sbindir}/

# Remove unpackaged files from the buildroot.
rm -f $RPM_BUILD_ROOT%{_libdir}/sasl2/libotp.*
rm -f $RPM_BUILD_ROOT%{_libdir}/sasl2/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/sasl2/*.la
rm -f $RPM_BUILD_ROOT%{_mandir}/cat8/saslauthd.8

%clean
test "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT

%pre
groupadd -g %{uid} -r %{username} >/dev/null  2>&1 || :
useradd -r -u %{uid} -g qemu -g %{username} -d %{homedir} -s /sbin/nologin -c \"%{hint}\" %{username} >/dev/null 2>&1 || :

%post
/sbin/chkconfig --add saslauthd

%preun
if [ $1 -eq 0 ] ; then
        /etc/init.d/saslauthd stop 2>&1 > /dev/null
        /sbin/chkconfig --del saslauthd
fi

%postun
if [ $1 -ne 0 ] ; then
        /etc/init.d/saslauthd stop 2>&1 > /dev/null
fi
userdel %{username} >/dev/null 2>&1 || :
groupdel %{username} >/dev/null 2>&1 || :

%post lib -p /sbin/ldconfig
%postun lib -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc saslauthd/LDAP_SASLAUTHD
%dir %{_plugindir2}/
%{_mandir}/man8/*
%{_sbindir}/pluginviewer
%{_sbindir}/saslauthd
%{_sbindir}/testsaslauthd
%config(noreplace) /etc/sysconfig/saslauthd
/etc/rc.d/init.d/saslauthd
/var/run/saslauthd

%files lib
%defattr(-,root,root)
%doc AUTHORS COPYING NEWS README doc/*.html
%{_libdir}/libsasl*.so.*
%dir %{_sysconfdir}/sasl2
%dir %{_plugindir2}/
%{_plugindir2}/*anonymous*.so*
%{_plugindir2}/*sasldb*.so*
%{_sbindir}/saslpasswd2
%{_sbindir}/sasldblistusers2

%files plain
%defattr(-,root,root)
%{_plugindir2}/*plain*.so*
%{_plugindir2}/*login*.so*

%if ! %{bootstrap_cyrus_sasl}
%files ldap
%defattr(-,root,root)
%{_plugindir2}/*ldapdb*.so*
%endif

%files md5
%defattr(-,root,root)
%{_plugindir2}/*crammd5*.so*
%{_plugindir2}/*digestmd5*.so*

%files ntlm
%defattr(-,root,root)
%{_plugindir2}/*ntlm*.so*

%files sql
%defattr(-,root,root)
%{_plugindir2}/*sql*.so*

%files gssapi
%defattr(-,root,root)
%{_plugindir2}/*gssapi*.so*

%files devel
%defattr(-,root,root)
%doc doc/*.txt
%{_bindir}/sasl2-sample-client
%{_bindir}/sasl2-sample-server
%{_includedir}/*
%{_libdir}/libsasl*.*so
%{_mandir}/man3/*
%{_sbindir}/sasl2-shared-mechlist
%{_libdir}/*.la

%changelog
* Tue Jun 29 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.1.23-3
- rebuilt against mysql 5.1.47 
* Sun Jan 24 2010 Christian Metzen <metzench@ccux-linux.de> 2.1.23-2
- build with sql support, separate auth packages
- add working saslauthd init script
* Wed Aug 05 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.1.23-1
- Version update
* Wed Aug 30 2006 Christian Metzen <metzench@ccux-linux.de> 2.1.22-3
- removed mysql dependency
* Tue Aug 29 2006 Simon Schmeisser <mail_to_wrt@gmx.de> 2.1.22-2
- Fixed wrong path to plugins
* Sun Jul 02 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.1.22-1
- Version update
* Sun Jul 24 2005 Christian Metzen <metzench@ccux-linux.de> 2.1.20-5
- More fixes
* Sat Jul 23 2005 Christian Metzen <metzench@ccux-linux.de> 2.1.20-4
- Fixed minor Bug
* Thu Jul 14 2005 Christian Metzen <metzench@ccux-linux.de> 2.1.20-3
- Moved more files to devel package
* Sun Jul 10 2005 Karsten Brockmann <brockmka@rz.fh-augsburg.de> 2.1.20-2
- rebuilt against openssl 0.9.8
* Sun Apr 03 2005 Christian Metzen <metzench@ccux-linux.de> 2.1.20-1
- Initial Release
